diff --git a/src/interfaces/libpq/fe-connect.c b/src/interfaces/libpq/fe-connect.c
new file mode 100644
index e2a06b3..083e6df
*** a/src/interfaces/libpq/fe-connect.c
--- b/src/interfaces/libpq/fe-connect.c
*************** parseServiceFile(const char *serviceFile
*** 4061,4066 ****
--- 4061,4076 ----
  				}
  				*val++ = '\0';
  
+ 				if (strcmp(key, "service") == 0)
+ 				{
+ 					printfPQExpBuffer(errorMessage,
+ 									  libpq_gettext("nested service specifications not supported in service file \"%s\", line %d\n"),
+ 									  serviceFile,
+ 									  linenr);
+ 					fclose(f);
+ 					return 3;
+ 				}
+ 
  				/*
  				 * Set the parameter --- but don't override any previous
  				 * explicit setting.
